/*
 * lab1.c
 */

#include "lcd.h"
#include "usart.h"

#include <avr/io.h>
#include <util/delay.h>


#define MORSE_LUNG  3
#define MORSE_SCURT 1

/* Literele alfabetului in cod Morse */
char* morse_alphabet[] = {
    (char*)"13",    // a
    (char*)"3111",  // b
    (char*)"3131",  // c
    (char*)"311",   // d
    (char*)"1",     // e
    (char*)"1131",  // f
    (char*)"331",	// g
    (char*)"1111",	// h
    (char*)"11",	// i
    (char*)"1333",	// j
    (char*)"313",	// k
    (char*)"1311",	// l
    (char*)"33",	// m
    (char*)"31",	// n
    (char*)"333",	// o
    (char*)"1331",	// p
    (char*)"3313",	// q
    (char*)"131",	// r
    (char*)"111",	// s
    (char*)"3",	    // t
    (char*)"113",	// u
    (char*)"1113",	// v
    (char*)"133",	// w
    (char*)"3113",	// x
    (char*)"3133",	// y
    (char*)"3311"	// z
};


void exemplu_usart()
{
    for(;;)
    {
        USART0_print("Salut!\n\r");
        _delay_ms(10);
    }
}

void task1()
{
    /* TODO task 1 */

    // configurare porturi folosite

    // main loop
    for(;;)
    {
        // cand PB2 este apasat trimite un mesaj pe USART o singura data

        // cand PB2 este lasat trimite un mesaj pe USART o singura data

        // cand PD6 este apasat trimite un mesaj pe USART o singura data

        // cand PD6 este lasat trimite un mesaj pe USART o singura data

        // much switch, so debouncing, such delay
        _delay_ms(5);
    }
}


/* apelati functia pentru a obtine un ton lung/scurt,
 * folosind macro-urile MORSE_LUNG si MORSE_SCURT
 */
void speaker_morse(int tip)
{
    int delay = 1;
    int i;
    DDRD |= (1 << PD4);     // PD4 trebuie sa fie output

    for (i = 0; i < tip * 50 / delay; i++)
    {
        PIND = (1 << PD4);  // alternam starea iesirii
        _delay_ms(1);
    }
}

void task2()
{
    /* TODO task 2*/

    // configurare porturi folosite

    // main loop
    for(;;)
    {
        // primeste un caracter
        // daca este caracter litera mica il reda in codul Morse
        // folosing  speaker_morse
    }
}


void exemplu_lcd()
{
    LCD_print("Hello World!");

    for(;;);
}

void task4a()
{
    /* TODO task 4a*/

    // configurare porturi folosite

    // initializari
    char str[] = "Hello World";
    LCD_print(str);

    // main loop
    for(;;)
    {
        // in functie de butoanele apasate, reafiseaza mesajul cu o pozitie
        // la stanga sau la dreapta fata de pozitia anterioara
        _delay_ms(5);
    }
}

void task4b()
{
    /* TODO task 4b */

    // main loop
    for(;;)
    {
            // primeste un caracter pe seriala,
            // il afiseaza pe ecran la pozitia curenta
            // daca noua pozitie a cursorului nu este intr-o zona vizibila,
            // trecem la cealalta linie
        }
    }

void bonus_usart()
{
    /* TODO bonus*/

    // configurari porturi folosite

    // configurarea stdout

    // main loop
    int8_t PB2_flag = 0, PD6_flag = 0;
    for(;;)
    {
        // cand PB2 este apasat trimite un mesaj pe USART
        if(!(PINB & (1 << PB2)) && !PB2_flag)
        {
            PB2_flag = 1;
            printf("PB2 apasat\n");
        }

        // cand PB2 este lasat trimite un mesaj pe USART
        if((PINB & (1 << PB2)) && PB2_flag)
        {
            PB2_flag = 0;
            printf("PB2 lasat\n");
        }

        // cand PD6 este apasat trimite un mesaj pe USART
        if(!(PIND & (1 << PD6)) && !PD6_flag)
        {
            PD6_flag = 1;
            printf("PD6 apasat\n");
        }

        // cand PD6 este lasat trimite un mesaj pe USART
        if((PIND & (1 << PD6)) && PD6_flag)
        {
            PD6_flag = 0;
            printf("PD6 lasat\n");
        }

        // much switch, so debouncing, such delay
        _delay_ms(5);
    }
}

int main()
{
    USART0_init();
    LCD_init();

    switch(0)
    {

        case 0: exemplu_usart();    break;
        case 1: task1();      break;
        case 2: task2();      break;
        case 3: exemplu_lcd();      break;
        case 4: task4a();        break;
        case 5: task4b();        break;
        
        //bonus
        case 6: bonus_usart();      break;
    }

    return 0;
}

